/*
PSConvert reads the pdf995.ini file and converts ..pdf995\temp.ps to the desired PDF 
Copyright (c) 2003 Software995 Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as published
by the Free Software Foundation v2.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston MA 02111-1307, USA


Software995 may be contacted by sending email to support@software995.com

*/


// psconvert.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "direct.h"
#include "stdio.h"

BOOL gl_bRunSharedNetwork = FALSE;
char gl_szSharedNetworkIni[2048];


char szDataFolder[2048] = TEXT("");
BOOL bDataFolderDetermined=FALSE;
/*
void GetDataFolderRoot(char *szRoot, char* szdatafolder, int len)
{
	if (bDataFolderDetermined)
	{
		strcpy(szdatafolder, szDataFolder);
		return;
	}

	char szIniFile[2048];
	strcpy(szIniFile, szRoot);
	strcat(szIniFile, TEXT("pdf995\\res\\pdf995.ini"));

	GetPrivateProfileString(TEXT("Parameters"),TEXT("Data Folder"), szRoot, szdatafolder, len, szIniFile);
	
	strcpy(szDataFolder, szdatafolder);
	bDataFolderDetermined = TRUE;

	if (_stricmp( szdatafolder, szRoot ) != 0)
	{
		strcpy(szIniFile, szdatafolder);
		strcat(szIniFile, TEXT("pdf995"));
	}
	return;
}
*/

BOOL IsXPor2000()
{
   OSVERSIONINFOEX osvi;
   BOOL bOsVersionInfoEx;

   // Try calling GetVersionEx using the OSVERSIONINFOEX structure,
   // which is supported on Windows 2000.
   //
   // If that fails, try using the OSVERSIONINFO structure.

   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
      // If OSVERSIONINFOEX doesn't work, try OSVERSIONINFO.

      osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
         return FALSE;
   }

   if ( osvi.dwMajorVersion <= 4 )
           return FALSE;//printf( "Microsoft Windows NT ");

    //     if ( osvi.dwMajorVersion == 5 )
    //       printf ("Microsoft Windows 2000 ");

   return TRUE; 
}

#include "shlobj.h"
void GetDataFolderRoot(char *szRoot, char* szdatafolder, int len)
{
	char szIniFile[2048];
	if (bDataFolderDetermined)
	{
		strcpy(szdatafolder, szDataFolder);
		return;
	}

	strcpy(szIniFile, szRoot);
	strcat(szIniFile, TEXT("pdf995\\res\\pdf995.ini"));

	GetPrivateProfileString(TEXT("Parameters"),TEXT("Data Folder"), "", szdatafolder, len, szIniFile);
	
	if (strlen(szdatafolder) == 0)
	{
		if (IsXPor2000())
		{
			LPITEMIDLIST ppidl;
			HRESULT resulth;
			HWND hWnd = GetDesktopWindow();

			char temp[MAX_PATH];

			//attempt to use other function
			resulth = SHGetSpecialFolderLocation(
			hWnd,
			0x0023, ////CSIDL_COMMON_APPDATA            0x0023
			&ppidl
			);

			SHGetPathFromIDList(ppidl,temp);

			strcpy(szdatafolder, temp);
			strcat(szdatafolder, TEXT("\\"));


		}
		else
		{
			strcpy(szdatafolder, szRoot);
		}

	}

	strcpy(szDataFolder, szdatafolder);
	bDataFolderDetermined = TRUE;

	return;
}



void GetPdf995Path(char *szRoot, DWORD *szlen)
{
	HKEY hkey1;
	DWORD type1 = REG_SZ;
	long rc;
	char subkeyname[] = TEXT("Software\\Pdf995");
	 if ((RegOpenKeyEx(HKEY_LOCAL_MACHINE,(const char*) &subkeyname, 0, 
	  KEY_READ, &hkey1)) == ERROR_SUCCESS)
	 {	 
		rc = RegQueryValueEx(hkey1, TEXT("Path"), NULL, &type1, 
			(LPBYTE)szRoot, szlen);
		if (rc != ERROR_SUCCESS)
		{

			strcpy(szRoot,  TEXT("c:\\"));
		}
		RegCloseKey(hkey1);
	 }
	 else
	 {
		strcpy(szRoot,  TEXT("c:\\"));
	 }

	if (gl_bRunSharedNetwork)
	{
		char *ptr;
		char szTemp[2048];
		strcpy(szTemp, gl_szSharedNetworkIni);
		ptr = strrchr(szTemp, '\\');
		ptr[0] = NULL;
		ptr = strrchr(szTemp, '\\');
		ptr[0] = NULL;
		ptr = strrchr(szTemp, '\\');
		ptr[1] = NULL;
		strcpy(szRoot, szTemp);
	}

	 return;
}


#define MAXSTR 1028

//#include "C:\PROGRAM FILES\MICROSOFT SDK\INCLUDE\WinBase.h"

BOOL CreateProc(char* cmd, PROCESS_INFORMATION *pInfo, BOOL bVisible)
{
	
	int ret;
	VOID* envstrings = GetEnvironmentStrings();
	STARTUPINFO         sInfo;

	sInfo.cb              = sizeof(STARTUPINFO);
	sInfo.lpReserved      = NULL;
	sInfo.lpReserved2     = NULL;
	sInfo.cbReserved2     = 0;
	sInfo.lpDesktop       = NULL;
	sInfo.lpTitle         = NULL;
	sInfo.dwFlags         = 0;
	sInfo.dwX             = 0;
	sInfo.dwY             = 0;
	sInfo.dwFillAttribute = 0;
	sInfo.wShowWindow     = SW_SHOWNORMAL;

	if (!bVisible)
	{
		sInfo.dwFlags         = STARTF_USESHOWWINDOW;
		sInfo.wShowWindow     = SW_HIDE;
	}


	if (ret = CreateProcess(NULL,
	   (char*)(const char*)cmd,
				 NULL,
				 NULL,
				 FALSE,
				 CREATE_NEW_PROCESS_GROUP,
				 //0x00004000, //BELOW_NORMAL_PRIORITY_CLASS,
				 (void*)(const char*)envstrings,
				 NULL,
				 &sInfo,
				 pInfo) == 0) 
	{;}


	return TRUE;

}

#include "shlobj.h"

void GetUserModeServerFile(char *szServer)
{
	HWND hWnd = GetDesktopWindow();
	char temp[MAX_PATH];
	//attempt to use other function
	LPITEMIDLIST ppidl;	
	HRESULT resulth = SHGetSpecialFolderLocation(
	hWnd,
	0x001A,// CSIDL_LOCAL_APPDATA,
	&ppidl
	);
	
	SHGetPathFromIDList(ppidl,szServer);

	strcat(szServer, TEXT("\\pdf995"));
	CreateDirectory(szServer, NULL);
	strcat(szServer, TEXT("\\pdf995server.ini"));

	return;
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	int i = 0;
	//HANDLE hfile;

	DWORD res;

	DWORD byteswritten;

	PROCESS_INFORMATION piProcInfo;
	PROCESS_INFORMATION piProcInfo1;

	char  szBuf[1024];
	char szParameters[1024];
	char szdatafolderroot[2048];


	BOOL bUseDefaultDistiller;
	BOOL bInsertStationery;
	BOOL bAutoDocInfo;

	char szIni[1024];
	char szTempPDF[1024];
	BOOL bTempPDF;
	char szRoot[1024];
	DWORD szlen =1024;
	char sztmp[1024];
	GetPdf995Path(szIni, &szlen);
	strcat(szIni, TEXT("pdf995\\res\\pdf995.ini"));
	char	szwBuf[1024];

//MessageBox( NULL, TEXT("Test"), TEXT("Pdf995 PSConvert called"), MB_OK);



	GetPrivateProfileString(TEXT("Parameters"),TEXT("Server Name"), TEXT(""), gl_szSharedNetworkIni, sizeof(gl_szSharedNetworkIni), TEXT("pdf995.ini"));
	if (strlen(gl_szSharedNetworkIni) > 1)
		gl_bRunSharedNetwork = TRUE;
	else
	{
		char szServerIni[MAX_PATH];
		GetUserModeServerFile(szServerIni);
		GetPrivateProfileString(TEXT("Parameters"),TEXT("Server Name"), TEXT(""), gl_szSharedNetworkIni, sizeof(gl_szSharedNetworkIni), szServerIni);
		if (strlen(gl_szSharedNetworkIni) > 1)
			gl_bRunSharedNetwork = TRUE;
		else
			gl_bRunSharedNetwork = FALSE;
	}
/*
	FILE * tfile;
	tfile = fopen( szIni, TEXT("r") );
	if (tfile)
	{
		gl_bRunSharedNetwork = FALSE;
		fclose(tfile);
	}
	else
	{
		gl_bRunSharedNetwork = TRUE;
	}
*/

	if (gl_bRunSharedNetwork)
	{
		//GetPrivateProfileString(TEXT("Parameters"),TEXT("Server Name"), TEXT(""), gl_szSharedNetworkIni, sizeof(gl_szSharedNetworkIni), TEXT("pdf995.ini"));
		strncat( gl_szSharedNetworkIni, TEXT("\\pdf995\\res\\pdf995.ini"), strlen("\\pdf995\\res\\pdf995.ini"));
		strcpy(szIni, gl_szSharedNetworkIni);
	}
	else
	{
		gl_szSharedNetworkIni[0] = NULL;
	}




	GetPdf995Path(szRoot, &szlen);
	strcat(szRoot, TEXT("pdf995\\res\\convert"));
	
	_chdir(szRoot);



	BOOL is_winnt, is_win4;
	is_winnt = FALSE;
	is_win4 = FALSE;
	DWORD version = GetVersion();
     if ((HIWORD(version) & 0x8000)==0)
	  is_winnt = TRUE;
     if (LOBYTE(LOWORD(version)) >= 4)
	  is_win4 = TRUE;	

		if (is_winnt || !is_win4)
		{
			//nt
			GetPrivateProfileString(TEXT("Parameters"),TEXT("User File"), TEXT("0"), szBuf, sizeof(szBuf), szIni);
		}
		else
		{
			//98
			GetPrivateProfileString(TEXT("Parameters"),TEXT("PDF File"), TEXT("0"), szBuf, sizeof(szBuf), szIni);
		}
		
		GetPrivateProfileString(TEXT("Parameters"),TEXT("Conversion Parameters"), TEXT("-sDEVICE=pdfwrite -q -dPDFSETTINGS=/prepress -dCompatibilityLevel=1.3 -dNOPAUSE -dBATCH"), szParameters, sizeof(szParameters), szIni);
		
		
		GetPdf995Path(szRoot, &szlen);
		GetDataFolderRoot(szRoot, szdatafolderroot, sizeof(szdatafolderroot));

		
		GetPrivateProfileString(TEXT("Parameters"),TEXT("Use Temp PDF"), TEXT("0"), szTempPDF, sizeof(szTempPDF), szIni);
		bTempPDF = strcmp(szTempPDF, "1");
		if (!bTempPDF)
		{
			GetDataFolderRoot(szRoot, szTempPDF, sizeof(szdatafolderroot));
			strcat(szTempPDF, TEXT("pdf995\\~tpdf.pdf"));

			sprintf(szwBuf, TEXT("%spdf995\\res\\convert\\gswin32c.exe %s -sOutputFile=\"%s\" -c save pop -f \"%spdf995\\temp.ps\""), szRoot, szParameters, szTempPDF, szdatafolderroot);
		}
		else
		{
			sprintf(szwBuf, TEXT("%spdf995\\res\\convert\\gswin32c.exe %s -sOutputFile=\"%s\" -c save pop -f \"%spdf995\\temp.ps\""), szRoot, szParameters, szBuf, szdatafolderroot);
		}


//MessageBox( NULL, szwBuf, TEXT("Pdf995 Warning"), MB_OK);


		if (CreateProc(szwBuf, &piProcInfo, FALSE))
		{
			WaitForSingleObject(piProcInfo.hProcess, 8*60*1000);
		}

		if (!bTempPDF)
		{
			DeleteFile(szBuf);
			MoveFile(szTempPDF, szBuf);
			DeleteFile(szTempPDF);
		}


		sprintf(szwBuf, TEXT("%spdf995\\res\\convert\\gs_pdfwr.ps"), szRoot);
		res = GetFileAttributes(szwBuf);
		if (res == -1)
		{
			MessageBox( NULL, TEXT("Please install the Free Converter for Pdf995. You can download it free from www.pdf995.com."), TEXT("Pdf995 Warning"), MB_OK);
		}


		HANDLE hfile = CreateFile(szBuf, GENERIC_WRITE, 0, 
			NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hfile != 0)
		{
			DWORD dwsize;
			dwsize = GetFileSize(hfile, NULL);
			if (dwsize == -1 || dwsize == 0)
			{
				CloseHandle(hfile  // handle to object
				);

				GetDataFolderRoot(szRoot, szTempPDF, sizeof(szdatafolderroot));
				strcat(szTempPDF, TEXT("pdf995\\~tpdf.pdf"));


				sprintf(szwBuf, TEXT("%spdf995\\res\\convert\\gswin32c.exe %s -sOutputFile=\"%s\" -c save pop -f \"%spdf995\\temp.ps\""), szRoot, szParameters, szTempPDF, szdatafolderroot);
				
				if (CreateProc(szwBuf, &piProcInfo, FALSE))
				{
					WaitForSingleObject(piProcInfo.hProcess, 8*60*1000);
				}
				DeleteFile(szBuf);
				MoveFile(szTempPDF, szBuf);
				DeleteFile(szTempPDF);
			}
			else
			{
				CloseHandle(hfile  // handle to object
				);
			}

		}



	return 0;
}



